#include "sprox_mifplus_i.h"

#ifdef _WITH_SELFTEST

static const BYTE N_9_8_1[]   = { 0xCF, 0xC1, 0x0C, 0x4F, 0x63, 0x05, 0x3E, 0x15, 0x08, 0x25, 0xC8, 0xC7, 0xE8, 0x05, 0xF3, 0x02 };
static const BYTE N_9_8_4[]   = { 0x1E, 0x65, 0xA4, 0x79, 0x94, 0xD0, 0xA9, 0x65, 0x33, 0x08, 0x61, 0xC2, 0x45, 0x86, 0x46, 0xCE };

static const BYTE C_9_8_1_A[] = { 0x70, 0x04, 0x40, 0x06, 0x29, 0x06, 0x34, 0x10, 0x01, 0x04 };
static const BYTE R_9_8_1_A[] = { 0x90, 0x6D, 0xAF, 0x3E, 0x03, 0x08, 0xD6, 0x6A, 0xB8, 0x0A, 0xD9, 0xBC, 0x7F, 0x41, 0x1A, 0x34, 0xF2 };

static const BYTE C_9_8_1_B[] = { 0x72, 0x71, 0xF9, 0x66, 0x56, 0x27, 0x11, 0x0C, 0xE1, 0xD1, 0x0D, 0xC2, 0xDF, 0xBE, 0x17, 0x8E, 0x51, 0xA2, 0xE7, 0x22, 0x27, 0x31, 0x3F, 0x0A, 0xFA, 0x1B, 0xAB, 0xE8, 0x4F, 0xBA, 0x57, 0xD5, 0x49 };
static const BYTE R_9_8_1_B[] = { 0x90, 0x67, 0x3C, 0xAD, 0x29, 0x07, 0x0A, 0xFB, 0x6C, 0x4C, 0x32, 0x62, 0xAE, 0xEB, 0x4A, 0x51, 0xBE, 0x1F, 0xC7, 0xD1, 0xB3, 0xD1, 0x08, 0x23, 0xCF, 0x1D, 0x4A, 0x7E, 0x54, 0x27, 0x0B, 0x13, 0x13 };

static const BYTE C_9_8_2[]   = { 0xA1, 0x09, 0x00, 0x18, 0xA4, 0xAB, 0xE3, 0x07, 0xA2, 0x03, 0xD8, 0x7A, 0xA5, 0xDB, 0xBB, 0x0A, 0xF1, 0x6F, 0x70, 0xBC, 0x43, 0x05, 0xFE, 0x72, 0x9F, 0xBD, 0x03 };
static const BYTE R_9_8_2[]   = { 0x90, 0x74, 0x6F, 0xE8, 0x11, 0x0E, 0xB2, 0x1C, 0xA9 };

static const BYTE C_9_8_3[]   = { 0xA1, 0x0A, 0x00, 0x10, 0x3E, 0x4B, 0x9E, 0x73, 0x38, 0x4F, 0x8F, 0xB7, 0x9B, 0x02, 0xF0, 0x63, 0x1B, 0x4B, 0x45, 0xE5, 0x88, 0x17, 0x68, 0x83, 0xD3, 0x90, 0x8F };
static const BYTE R_9_8_3[]   = { 0x90, 0xC2, 0xFB, 0x0E, 0x11, 0x94, 0x70, 0xDF, 0x1C };

static const BYTE C_9_8_4_A[] = { 0x76, 0x09, 0x40 };
static const BYTE R_9_8_4_A[] = { 0x90, 0x10, 0x64, 0x53, 0x05, 0xC6, 0x83, 0xC4, 0xC3, 0x3C, 0xA1, 0x33, 0xF6, 0xD0, 0x67, 0xAC, 0xFB };

static const BYTE C_9_8_4_B[] = { 0x72, 0xD8, 0x3C, 0x0D, 0x0B, 0xAD, 0x1D, 0xF4, 0x50, 0x82, 0x20, 0x11, 0x45, 0xC4, 0x0F, 0x61, 0x3A, 0xF1, 0xFF, 0x30, 0xCF, 0x0B, 0x0B, 0x38, 0x29, 0x29, 0xB6, 0x7D, 0x11, 0xB4, 0xF5, 0x44, 0x81 };
static const BYTE R_9_8_4_B[] = { 0x90, 0x88, 0xB9, 0x18, 0x28, 0x70, 0x09, 0x94, 0xE7, 0xE5, 0x61, 0x75, 0xEA, 0x81, 0xD1, 0x8C, 0xAF };

static const BYTE C_9_8_5[]   = { 0x31, 0x11, 0x00, 0x01, 0x5E, 0xB6, 0x48, 0xC9, 0x3B, 0x9E, 0xE9, 0xB8 };
static const BYTE R_9_8_5[]   = { 0x90, 0x75, 0x97, 0x11, 0xAF, 0xF8, 0xB6, 0xE3, 0x07, 0xE7, 0x1B, 0x8A, 0x92, 0x70, 0x9C, 0xA6, 0xF0, 0xFF, 0x1C, 0x4A, 0x5D, 0xDC, 0xE3, 0x16, 0x8D };

static const BYTE C_9_8_6[]   = { 0x31, 0x12, 0x00, 0x01, 0xAE, 0xA9, 0xCA, 0x32, 0x60, 0xC1, 0x07, 0x34 };
static const BYTE R_9_8_6[]   = { 0x90, 0x8A, 0xDC, 0xC4, 0xC6, 0x45, 0x1A, 0x23, 0xBB, 0x6C, 0x1D, 0xED, 0xE0, 0x2D, 0xF3, 0xAB, 0x72, 0x07, 0x48, 0xAF, 0x73, 0x14, 0x48, 0x96, 0x70 };

static int last_cmd = 0;

SPROX_RC MifPlus_CommandHook(SPROX_PARAM  const BYTE cmd_buffer[], WORD cmd_len, BYTE rsp_buffer[], WORD rsp_max_len, WORD *rsp_got_len)
{
  WORD i;

  printf("MfpH<");
	for (i=0; i<cmd_len; i++)
	  printf("%02X", cmd_buffer[i]);
	printf("\n");

	last_cmd = 0;

  if ((cmd_len == sizeof(C_9_8_1_A)) && !memcmp(cmd_buffer, C_9_8_1_A, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_1_A);
    memcpy(rsp_buffer, R_9_8_1_A, *rsp_got_len);	
		last_cmd = 981;
	} else
  if ((cmd_len == sizeof(C_9_8_1_B)) && !memcmp(cmd_buffer, C_9_8_1_B, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_1_B);
    memcpy(rsp_buffer, R_9_8_1_B, *rsp_got_len);	
	} else
  if ((cmd_len == sizeof(C_9_8_2)) && !memcmp(cmd_buffer, C_9_8_2, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_2);
    memcpy(rsp_buffer, R_9_8_2, *rsp_got_len);	
	} else
  if ((cmd_len == sizeof(C_9_8_3)) && !memcmp(cmd_buffer, C_9_8_3, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_3);
    memcpy(rsp_buffer, R_9_8_3, *rsp_got_len);	
	} else
  if ((cmd_len == sizeof(C_9_8_4_A)) && !memcmp(cmd_buffer, C_9_8_4_A, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_4_A);
    memcpy(rsp_buffer, R_9_8_4_A, *rsp_got_len);	
		last_cmd = 984;
	} else
  if ((cmd_len == sizeof(C_9_8_4_B)) && !memcmp(cmd_buffer, C_9_8_4_B, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_4_B);
    memcpy(rsp_buffer, R_9_8_4_B, *rsp_got_len);	
	} else
  if ((cmd_len == sizeof(C_9_8_5)) && !memcmp(cmd_buffer, C_9_8_5, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_5);
    memcpy(rsp_buffer, R_9_8_5, *rsp_got_len);	
	} else
  if ((cmd_len == sizeof(C_9_8_6)) && !memcmp(cmd_buffer, C_9_8_6, cmd_len))
	{
	  *rsp_got_len = sizeof(R_9_8_6);
    memcpy(rsp_buffer, R_9_8_6, *rsp_got_len);	
	} else
	  return -1;

  printf("MfpH>");
	for (i=0; i<*rsp_got_len; i++)
	  printf("%02X", rsp_buffer[i]);
	printf("\n");

	return 0;
}

void GetRandomBytes_Hook(SPROX_PARAM  BYTE rnd[], DWORD size)
{
  switch (last_cmd)
	{
    case 981 : memcpy(rnd, N_9_8_1, size); break;
		case 984 : memcpy(rnd, N_9_8_4, size); break;
    default  : break;
	}


	last_cmd = 0;
}


LONG SCardMifPlus_SelfTest(SPROX_PARAM_V)
{
  const BYTE key_4004[16]  = { 0x8D, 0xDF, 0xF1, 0x51, 0xA6, 0xEF, 0x6A, 0x7F, 0xE6, 0xD0, 0x33, 0x3A, 0x42, 0xBE, 0x21, 0xEE };
	const BYTE key_4009[16]  = { 0x1D, 0xD6, 0x62, 0x9D, 0x8D, 0x44, 0x35, 0x30, 0x98, 0x0E, 0x43, 0x08, 0x4A, 0x52, 0x59, 0xFA };
	const BYTE pcd_cap[6]    = { 0x29, 0x06, 0x34, 0x10, 0x01, 0x04 };
	const BYTE data_0009[16] = { 0x32, 0x14, 0xA5, 0xF4, 0xDE, 0x18, 0xAE, 0xC8, 0xDA, 0x6F, 0x50, 0x33, 0x32, 0xB7, 0x10, 0xD7 };
	const BYTE data_000A[16] = { 0x02, 0xBB, 0x2A, 0x18, 0xBA, 0x7C, 0x4B, 0x54, 0xFC, 0x9F, 0x8C, 0xAE, 0x37, 0x7F, 0x5C, 0x1A };
	const BYTE data_0011[16] = { 0x78, 0x56, 0x34, 0x12, 0x87, 0xA9, 0xCB, 0xED, 0x78, 0x56, 0x34, 0x12, 0x0A, 0xF5, 0x0A, 0xF5 };
	const BYTE data_0012[16] = { 0x60, 0x11, 0x16, 0x00, 0x9F, 0xEE, 0xE9, 0xFF, 0x60, 0x11, 0x16, 0x00, 0x12, 0xED, 0x12, 0xED };
	BYTE picc_cap[6];
	BYTE buffer[16];
	int i;
	LONG rc;
	SPROX_MIFPLUS_GET_CTX();

	in_selftest = TRUE;

	printf("PCD_CAP= ");
	for (i=0; i<sizeof(pcd_cap); i++)
	  printf("%02X", pcd_cap[i]);
	printf("\n");
	
  rc = SCardMifPlus_FirstAuthenticate(SPROX_PARAM_P  0x4004, key_4004, pcd_cap, sizeof(pcd_cap), picc_cap);
	if (rc)
	  goto done;

  rc = SCardMifPlus_Write(SPROX_PARAM_P  0x0009, data_0009);
	if (rc)
	  goto done;

  rc = SCardMifPlus_Write(SPROX_PARAM_P  0x000A, data_000A);
	if (rc)
	  goto done;

  rc = SCardMifPlus_FollowingAuthenticate(SPROX_PARAM_P  0x4009, key_4009);
	if (rc)
	  goto done;

  rc = SCardMifPlus_Read(SPROX_PARAM_P  0x0011, buffer);
	if (rc)
	  goto done;

	if (memcmp(buffer, data_0011, 16))
	{
    rc = -30;
		goto done;
	}

  rc = SCardMifPlus_Read(SPROX_PARAM_P  0x0012, buffer);
	if (rc)
	  goto done;

	if (memcmp(buffer, data_0012, 16))
	{
    rc = -30;
		goto done;
	}


done:
	in_selftest = FALSE;
	return rc;
}


#if 0
static const MIFPLUS_PERSO_ST mifplus_perso[] =
{
	/* Card Master Key */
	{ OPT_X_OR_S, 0x9000, { 0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* Card Configuration Key */
  { OPT_X_OR_S, 0x9001, { 0x01,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* Level 2 switch key */
  { OPT_ONLY_X, 0x9002, { 0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* Level 3 switch key */
  { OPT_X_OR_S, 0x9003, { 0x03,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* SL1 Card Authentication Key */
  { OPT_X_OR_S, 0x9004, { 0x04,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* Select VC key */
  { OPT_ONLY_X, 0xA000, { 0x05,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* Proximity check key */
  { OPT_ONLY_X, 0xA001, { 0x06,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},

	/* VC polling ENC key - must be constant among the system */
  { OPT_X_OR_S, 0xA080, { 0x07,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},
	/* VC polling MAC key - must be constant among the system */
  { OPT_X_OR_S, 0xA081, { 0x08,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00 }},

  /* MFP configuration block - see MifPlux X datasheet  10.11 */ 
//{ OPT_ONLY_X, 0xB000, { ...define new MFP configuration block here... }},

  /* MFP installation identifier - see MifPlux X datasheet  9.7.7 */ 
  { OPT_X_OR_S, 0xB001, { "SpringCard  test" }},

  /* ATS information - here we could modify the ATS. WE'D BETTER NOT!!! */ 
//{ OPT_X_OR_S, 0xB002, { ...define new ATS here... }},

  /* Field Configuration Block - see MifPlux X datasheet  10.10 */ 
//{ OPT_X_OR_S, 0xB003, { ...define new Field Configuration Block here... }},
};
#endif


#endif
